import sys
import os.path
libdir = os.path.dirname(__file__)
sys.path.append(os.path.split(libdir)[0])

import Data.DataGenerator as dg

import pandas as pd
import numpy as np
import math


#Deprecated method for reformatting generated data
def timesteps_first(timesteps_in, n_players=5):
    timesteps = timesteps_in
    moving_object = dg.MovingObject()
    x, y, z, c, = moving_object.generate(n_players, timesteps)
    x = x[2:]
    y = y[2:]
    z = z[2:]
    c = c[2:]

    data = np.zeros([timesteps, n_players, 4])

    counter = 0
    for i in range(n_players):
        for j in range(timesteps):
            data[j, i, 0] = x[counter]
            data[j, i, 1] = y[counter]
            data[j, i, 2] = z[counter]
            data[j, i, 3] = c[counter]
            counter += 1
    return data

def convert_state_to_matrix(state, shape):
    state_matrix = np.zeros(shape)
    labels = []
    for player_location in state:
        if math.ceil(player_location[3]) != 2795:
            labels.append(1)
        else:
            labels.append(0)
        player_location = player_location[:-1]
        if state_matrix[math.ceil(player_location[0])][math.ceil(player_location[1])][math.ceil(player_location[2])] == 0:
            state_matrix[math.ceil(player_location[0])][math.ceil(player_location[1])][math.ceil(player_location[2])] = 1
            print("Single")
        else:
            state_matrix[math.ceil(player_location[0])][math.ceil(player_location[1])][math.ceil(player_location[2])] = state_matrix[math.ceil(player_location[0])][math.ceil(player_location[1])][math.ceil(player_location[2])] + 1
            print("Double")
        

    #print(state_matrix)
    return state_matrix, labels


#gets the dataset specified by directory and returns it in $train and $test, with a 70-30 split: [matches, timesteps, players, features]
#specify min_shape if x or y values are below 0 - min_shape should then be the lowest possible values for x and y respectively
#to_scale should be indexes that contain values that are larger than 1, so they can be scaled to between 0 and 1.
#scalers should ten correspond to each index in to_scale, so that index i in to_scale is to be scaled by the i'th element in scalers
#if scale=False no values will be scaled
#The x and y positions will also be scaled by factor, default 1
def get_data_from_dir(directory, n_players, min_shape=(-2670, -1890), scalers=(8070, 3780, 1000), to_scale=[0, 1, 2], scale=False, factor=1):
    matches = []
    for subdir, dirs, files in os.walk(directory, topdown=False):
        for file in sorted(files):
            path = os.path.join(subdir, file)
            match = np.array(pd.read_csv(path, delimiter=",", header=None))
            match = np.reshape(match, [match.shape[0], n_players, -1])
            matches.append(match)
    for i in range(len(matches)):
        matches[i][:, :, 0] = (matches[i][:, :, 0] - min_shape[0])/factor
        matches[i][:, :, 1] = (matches[i][:, :, 1] - min_shape[1])/factor
        if scale:
            for j in range(len(to_scale)):
                matches[i][:, :, to_scale[j]] = matches[i][:, :, to_scale[j]]/scalers[j]

    train_length = int(len(matches) * 0.7)
    if train_length < 1:
        train_length = 1

    train = matches[:train_length]
    test = matches[train_length:]

    return train, test