import unittest
import numpy as np
import sys
import os.path
libdir = os.path.dirname(__file__)
sys.path.append(os.path.split(libdir)[0])
from Data import DataFormatter as df

class DataFormatterTest(unittest.TestCase):

    def test_format(self):
        data = df.timesteps_first(100)

        self.assertEqual(data.shape, (100, 5, 4), "Should be equal")
    
    def test_convert_state_to_matrix(self):
        state = [
            [7.73626270e-04, 5.06231901e-01, 2.26563446e-01, 1.00000000e+00, 0.00000000e+00, 1.00000000e+00], 
            [3.78172924e-03, 5.19890706e-01, 2.42000671e-01, 1.00000000e+00,0.00000000e+00, 1.00000000e+00]
            ]
        matrix, _ = df.convert_state_to_matrix(state, (2, 2, 2))
        print(matrix)
        answer = [[[0., 0.], [0., 0.]], [[0., 0.], [0., 2.]]]
        
        self.assertListEqual(matrix.tolist(), answer, "Should be equal")

if __name__ == "__main__":
    unittest.main()